\\ Copyright 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)


  \\  3       4       5
  \\  6       8      10      [3 - 4 - 5]
  \\  5      12      13
  \\  9      12      15      [3 - 4 - 5]
  \\  8      15      17
  \\ 12      16      20      [3 - 4 - 5]
  \\  7      24      25
  \\ 15      20      25      [3 - 4 - 5]
  \\ 10      24      26      [5 - 12 - 13]
  \\ 20      21      29
  \\ 18      24      30      [3 - 4 - 5]
  \\ 16      30      34      [8 - 15 - 17]
  \\ 21      28      35      [3 - 4 - 5]
  \\ 12      35      37
  \\ 15      36      39      [5 - 12 - 13]
  \\ 24      32      40      [3 - 4 - 5]
  \\  9      40      41
  \\ 27      36      45      [3 - 4 - 5]
  \\ 14      48      50      [7 - 24 - 25]
  \\ 30      40      50      [3 - 4 - 5]
  \\ 24      45      51      [8 - 15 - 17]
  \\ 20      48      52      [5 - 12 - 13]

\\ cf A105520 area+perimeter
{
  my(l=List([]));
  for(a=1,60,
     for(b=a,60,
        my(cc=a^2+b^2, c);
        issquare(cc,&c) || next;
        listput(l,[c,b,a])));
  l=Vec(l);
  l=vecsort(l);
  l=Vec(l,25);
  l=apply(Vecrev,l);
  print(l);

  my(ap=List([]));
  for(i=1,#l,
     my(elem=l[i],
        area=elem[1]*elem[2]/2,
        boundary=vecsum(elem),
        t=area+boundary);
     listput(ap,t);
     print(t"  "elem,
          if(gcd(elem)!=1,
             Str("       ",elem/gcd(elem)),
            "")));
  ap=Vec(ap);
  ap=vecsort(ap);
  print(ap);
}


\\ x*y/2 + x + y + z >= x^2/2 + 3x
\\ x^2 + 3x - m = 0
\\ x = -3 + sqrt(9 + 4*m)