\\ Copyright 2014, 2015, 2016, 2017, 2018, 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.


\\ THIS IS A GENERATED FILE
\\ Extracted from rationals.tex by gp-inline.
\\
\\ These are Pari/GP functions and definitions used in rationals.tex for
\\ various self-tests and formula checking there.  Names and styles are
\\ highly specific to the calculations there, and many things will change or
\\ disappear, etc, but some of the functions might be useful for
\\ experimenting or testing.


/* ------------------------------------------------------------------------- */
/* gp-inline test boilerplate begin */
gp_inline__location = "";
gp_inline__good = 0;
gp_inline__bad = 0;
gp_inline__check(location,bool) =
{
  gp_inline__location = location;
  check(bool);
}
/* this is thinking about a check() for use in loops or "GP-Inline ..."
   testing, but it's not settled so don't rely on it */
check(bool) =
{
  /* use "===" so that a vector like [1] or float 1.0 not reckoned success */
  if(bool===1, gp_inline__good++,
     bool===0, gp_inline__bad++;
               print(gp_inline__location": gp-inline fail"),
     gp_inline__bad++;
     print(gp_inline__location": gp-inline expected result 0 or 1, got ",
           bool));
}
/* gp-inline test boilerplate end */
/* ------------------------------------------------------------------------- */

gp_inline__location="../triples.tex:174";
 default(strictargs,1);

gp_inline__location="../triples.tex:176";
 \\ my http://user42.tuxfamily.org/pari-geom/index.html
 iferr(read("tools/geom.gp"),e, \
    read("../tools/geom.gp"));

gp_inline__location="../triples.tex:180";
 iferr(read("tools/triples-oeis-samples.gp"),e, \
    read("../tools/triples-oeis-samples.gp"));

gp_inline__location="../triples.tex:183";
 nearly_equal(x,y) = abs(x - y) < 1e-10;

gp_inline__location="../triples.tex:185";
 vector_increments(v) = vector(#v-1,i, v[i+1]-v[i]);

gp_inline__location="../triples.tex:187";
 \\ n is an integer.  Return an integer whose decimal digits
 \\ are the bits of n.
 to_binary(n)=fromdigits(binary(n))*sign(n);

gp_inline__location="../triples.tex:195";
 \\ n is an integer with decimal digits representing bits.
 \\ Return the value of those bits.
 from_binary(n) = fromdigits(digits(n),2);

gp_inline__location="../triples.tex:201";
 \\ Return integer whose decimal digits are the ternary digits of n.
 to_ternary(n) = fromdigits(digits(n,3),10);

gp_inline__location="../triples.tex:207";
 \\ n is an integer whose decimal digits are in the range 0-2
 \\ and are taken to be ternary.  The return is their value
 \\ in ternary.
 from_ternary(n)=fromdigits(digits(n,10),3);

gp_inline__location="../triples.tex:230";
 u  = [2,-1; 1, 0];
 a  = [2, 1; 1, 0];
 d  = [1, 2; 0, 1];
 m1 = [1, 1; 0, 2];
 m2 = [2, 0; 1,-1];
 m3 = [2, 0; 1, 1];
 t  = [1, 3; 0, 2];

gp_inline__location="../triples.tex:239";
 u3 = [ 1,-2,2;  2,-1,2;  2,-2,3];
 a3 = [ 1, 2,2;  2, 1,2;  2, 2,3];
 d3 = [-1, 2,2; -2, 1,2; -2, 2,3];
 m1_3 = [2, 1,-1; -2, 2,2; -2, 1,3];
 m2_3 = [2, 1, 1;  2,-2,2;  2,-1,3];
 m3_3 = [2,-1, 1;  2, 2,2;  2, 1,3];
 t3 = [-2,3,3; -6,2,6; -6,3,7]

gp_inline__location="../triples.tex:247";
 \\ m is a 2x2 matrix, return its components as vector [a,b,c,d]
 m_to_abcd(m) = {
   matsize(m) == [2,2] || error();
   concat(Col(m)~);
 }

gp_inline__location="../triples.tex:254";
 \\ Pell(n) returns the n'th Pell number as per OEIS A000129.
 \\ Starting from n=0 is 0, 1, 2, 5, 12, 29, 70, ...
 \\ Negative n works too, reversing recurrence
 \\ Pell[n] = 2*Pell[n-1] + Pell[n-2]
 Pell(n)=([2,1;1,0]^n*[0;1])[1,1];

gp_inline__location="../triples.tex:270";
 \\ Pell_cumulative(n) returns cumulative Pell(0)+...+Pell(n),
 \\ as per OEIS A048739.
 Pell_cumulative(n)=sum(i=0,n,Pell(i));

gp_inline__location="../triples.tex:284";
 \\ Return a vector of digits of n in "base" (like digits()),
 \\ padded at the start (the high end) with 0s if necessary to
 \\ make length k.
 \\ n must be small enough to fit in k many digits.
 digits_padded(n,base,k) = {
   my(v = digits(n,base));
   if(#v>k, error("digits_padded() n=",n," is bigger than k=",k," digits"));
   concat(vector(max(0,k-#v)),v);
 }

gp_inline__location="../triples.tex:298";
 \\ mv is a vector of matrices,
 \\ d is depth,
 \\ rev=1 for reverse products.
 tree_row(mv, d, rev) = {
   vector(3^d,n,n--;
          my(v=digits_padded(n,d));
          if(rev, v=Vecrev(v));
          prod(i=1,#v, mv[v[i]+1]));
 }

gp_inline__location="../triples.tex:393";
 A_leg_from_pq(p,q) = p^2 - q^2;

gp_inline__location="../triples.tex:396";
 B_leg_from_pq(p,q) = 2*p*q;

gp_inline__location="../triples.tex:399";
 C_leg_from_pq(p,q) = p^2 + q^2;

gp_inline__location="../triples.tex:403";
 p_from_A_B_C(A,B,C) = sqrt((C+A)/2);

gp_inline__location="../triples.tex:410";
 q_from_A_B_C(A,B,C) = sqrt((C-A)/2);

gp_inline__location="../triples.tex:418";
 \\ v is a column matrix [p;q], return a column matrix [A;B;C]
 pq_to_ABC(v) = {
   my(p=v[1,1], q=v[2,1]);
   [ A_leg_from_pq(p,q);
     B_leg_from_pq(p,q);
     C_leg_from_pq(p,q) ];
 }

gp_inline__location="../triples.tex:740";
 abcd_to_3x3(a,b,c,d) = {
   [ ((a^2-c^2)-(b^2-d^2))/2, a*b-c*d, ((a^2-c^2)+(b^2-d^2))/2;
           a*c - b*d,         a*d+b*c,       a*c + b*d;
     ((a^2+c^2)-(b^2+d^2))/2, a*b+c*d, ((a^2+c^2)+(b^2+d^2))/2 ];
 }
 m2x2_to_3x3(m) = {
   matsize(m) == [2,2] || error();
   abcd_to_3x3(m[1,1],m[1,2], m[2,1],m[2,2]);
 }

gp_inline__location="../triples.tex:806";
 UAD_matrices = [u, a, d];

gp_inline__location="../triples.tex:808";
 \\ a vector of all [p;q] across row "depth"
 UAD_row_pq(depth,LtoH=0) = {
   vector(3^depth,n,n--;
     my(v=digits_padded(n,3,depth));
     if(!LtoH, v=Vecrev(v));
     prod(i=1,#v, UAD_matrices[v[i]+1]) * [2;1]);
 }

gp_inline__location="../triples.tex:822";
 UAD_row_p(depth,LtoH=0) = apply(v->v[1,1], UAD_row_pq(depth,LtoH));
 UAD_row_q(depth,LtoH=0) = apply(v->v[2,1], UAD_row_pq(depth,LtoH));

gp_inline__location="../triples.tex:825";
 \\ a vector of all [A;B;C] across row "depth"
 UAD_row_ABC(depth) = apply(pq_to_ABC, UAD_row_pq(depth));

gp_inline__location="../triples.tex:833";
 UAD_row_A(depth) = apply(v->v[1,1], UAD_row_ABC(depth));
 UAD_row_B(depth) = apply(v->v[2,1], UAD_row_ABC(depth));
 UAD_row_C(depth) = apply(v->v[3,1], UAD_row_ABC(depth));

gp_inline__location="../triples.tex:953";
 UAD_row_A_samples = {[3,5,21,15,7,55,45,39,119,77,33,65,35]};

gp_inline__location="../triples.tex:967";
 UAD_row_B_samples = {[4,12,20,8,24,48,28,80,120,36,56,72,12]};

gp_inline__location="../triples.tex:980";
 UAD_row_C_samples = {[5,13,29,17,25,73,53,89,169,85,65,97,37]};

gp_inline__location="../triples.tex:994";
 UAD_row_p_samples = {[2,3,5,4,4,8,7,8,12,9,7,9,6]};

gp_inline__location="../triples.tex:1006";
 UAD_row_q_samples = {[1,2,2,1,3,3,2,5,5,2,4,4,1]};

gp_inline__location="../triples.tex:1043";
  \\ this code by Remy Sigrist in A321782
  \\ row depth n>=1, across k>=1
  { my(M = [[1,-2,2; 2,-1,2; 2,-2,3],
            [1,2,2; 2,1,2; 2,2,3],
            [-1,2,2; -2,1,2; -2,2,3]]);
    M==[u3,a3,d3] || error();
  A321782_T(n,k) =
    (n > 0 && 0 < k && k <= 3^(n-1)) || error();
    my(t=[3; 4; 5], d=digits(3^(n-1)+k-1, 3));
    for(i=2, #d, t = M[d[i]+1] * t);
    return (sqrtint((t[1,1] + t[3,1])/2));
  }

gp_inline__location="../triples.tex:1059";
 \\ A321782 = p
 \\ using prod() high to low matrices, which is compact
 \\ but does matrix multiplies rather than matrix * column
 { my(M=[[2,-1;1,0], [2,1;1,0], [1,2;0,1]]);
   M==[u,a,d] || error();
   A321782_T_2x2_HtoL(n,k) = my(v=digits(k-1,3));
     (prod(i=#v-n+2,#v, M[if(i>0,v[i])+1]) * [2,1]~)[1];
 }

gp_inline__location="../triples.tex:1071";
 \\ A321782 = p, loop high to low
 { my(M=[[2,-1;1,0], [2,1;1,0], [1,2;0,1]]);
   M==[u,a,d] || error();
   A321782_T_2x2_LtoH(n,k) = my(v=digits(k-1,3), c=[2,1]~);
     for(i=#v-n+2,#v, c = M[if(i>0,v[i])+1] * c);  c[1];
 }

gp_inline__location="../triples.tex:1432";
 U_repeatedly_p(k) = k+2;
 U_repeatedly_q(k) = k+1;

gp_inline__location="../triples.tex:1445";
 U_repeatedly_A_leg(k) = 2*k + 3;

gp_inline__location="../triples.tex:1450";
 U_repeatedly_B_leg(k) = 2*(k+1)*(k+2);

gp_inline__location="../triples.tex:1457";
 U_repeatedly_C_leg(k) = 2*(k+1)*(k+2) + 1;

gp_inline__location="../triples.tex:1474";
U_repeatedly_A_samples = {[3,5,7,9,11]};

gp_inline__location="../triples.tex:1483";
U_repeatedly_B_samples = {[4,12,24,40,60]};

gp_inline__location="../triples.tex:1490";
U_repeatedly_C_samples = {[5,13,25,41,61]};

gp_inline__location="../triples.tex:1551";
 A_repeatedly_p(k) = Pell(k+2);
 A_repeatedly_q(k) = Pell(k+1);

gp_inline__location="../triples.tex:1560";
A_repeatedly_p_samples = {[2,5,12,29,70]};

gp_inline__location="../triples.tex:1566";
A_repeatedly_q_samples = {[1,2,5,12,29]};

gp_inline__location="../triples.tex:1590";
Pell_samples = {[0,1,2,5,12,29,70,169,408]};

gp_inline__location="../triples.tex:1610";
 A_repeatedly_A_leg(k) = 2*Pell(k+2)*Pell(k+1) - (-1)^k;

gp_inline__location="../triples.tex:1616";
 A_repeatedly_B_leg(k) = 2*Pell(k+2)*Pell(k+1);

gp_inline__location="../triples.tex:1619";
 A_repeatedly_C_leg(k) = Pell(2*k+3);

gp_inline__location="../triples.tex:1634";
A_repeatedly_A_samples = {[3,21,119,697]};

gp_inline__location="../triples.tex:1640";
A_repeatedly_B_samples = {[4,20,120,696]};

gp_inline__location="../triples.tex:1647";
A_repeatedly_C_samples = {[5,29,169,985]};

gp_inline__location="../triples.tex:1687";
 PellOblong(k) = {
     (Pell(k+1) + Pell(k))
   * (Pell(k+1) - Pell(k));
 }

gp_inline__location="../triples.tex:1700";
 PellOblong_samples = {[1,3,21,119,697,4059,23661]};

gp_inline__location="../triples.tex:1724";
 \\ A001333 sqrt(2) continued fraction numerators
 PellDiff(k) = Pell(k+1) - Pell(k);

gp_inline__location="../triples.tex:1800";
 D_repeatedly_p(k) = 2*k + 2;
 D_repeatedly_q(k) = 1;

gp_inline__location="../triples.tex:1813";
 D_repeatedly_A_leg(k) = (2*k+ 2)^2 - 1;

gp_inline__location="../triples.tex:1818";
 D_repeatedly_B_leg(k) = 4 * (k+1);

gp_inline__location="../triples.tex:1821";
 D_repeatedly_C_leg(k) = (2*k+ 2)^2 + 1;

gp_inline__location="../triples.tex:1837";
D_repeatedly_A_samples = {[3,15,35,63,99]};

gp_inline__location="../triples.tex:1844";
D_repeatedly_B_samples = {[4,8,12,16,20]};

gp_inline__location="../triples.tex:1853";
D_repeatedly_C_samples = {[5,17,37,65,101]};

gp_inline__location="../triples.tex:1928";
 UAD_row_total_B_sub_A(depth) = {
   my(v=UAD_row_ABC(depth));
   sum(i=1,#v, v[i][2,1] - v[i][1,1]);
 }

gp_inline__location="../triples.tex:2099";
 UAD_ptotal(k) = {
   k>=0 || error("UAD_ptotal() is for n>=0");
   Pell(2*k+2);
 }

gp_inline__location="../triples.tex:2104";
 UAD_ptotal_samples = {[2,12,70,408,2378,13860,80782]};

gp_inline__location="../triples.tex:2123";
 UAD_qtotal(n) = {
   n>=0 || error("UAD_qtotal() is for n>=0");
   Pell(2*n+1);
 }

gp_inline__location="../triples.tex:2128";
 UAD_qtotal_samples = {[1,5,29,169,985,5741,33461]};

gp_inline__location="../triples.tex:2139";
 UAD_row_p_total(depth) = {
   my(v=UAD_row_pq(depth));
   sum(i=1,#v, v[i][1,1]);
 }

gp_inline__location="../triples.tex:2146";
 UAD_row_q_total(depth) = {
   my(v=UAD_row_pq(depth));
   sum(i=1,#v, v[i][2,1]);
 }

gp_inline__location="../triples.tex:2305";
 UAD_next_q1_formula(p) = {
   [ 1/2*p + 2;
     1/2*p + 1 ];
 }

gp_inline__location="../triples.tex:2319";
 UAD_next_odd_formula(p,q,m,r) = {
    [ p + 2*q - 1/2 * (m+3) * r;
      p       - 1/2 * (m+1) * r ];
 }

gp_inline__location="../triples.tex:2332";
 UAD_next_even_formula(p,q,m,r) = {
   [ 1/2*p     + 1/2 * (m+1) * r;
     1/2*p - q + 1/2 * (m-1) * r ];
 }

gp_inline__location="../triples.tex:2348";
 \\ return [m,r] from column matrix pq = [p;q]
 UAD_next_mr(pq) = {
   my(p=pq[1,1], q=pq[2,1]);
   divrem(p,q);
 }
 UAD_next_pq(pq) = {
   my(p=pq[1,1], q=pq[2,1]);
   if(q==1, UAD_next_q1_formula(p),
      my(m,r); [m,r] = UAD_next_mr(pq);
      if(m%2==1, UAD_next_odd_formula(p,q,m,r),
                 UAD_next_even_formula(p,q,m,r)));
  }

gp_inline__location="../triples.tex:2712";
 UAD_Rev(m) = {
   my(a,b,c,d); [a,b,c,d] = m_to_abcd(m);
        [ 2*c + d,  2*a + b - 4*c - 2*d;
            c,        a     - 2*c        ];
 }

gp_inline__location="../triples.tex:2827";
 UAD_Rev_combinations = [[0,0,2,1], [2,1,-4,-2]; \
                         [0,0,1,0], [1,0,-2,0]];

gp_inline__location="../triples.tex:2930";
 \\ v is a vector of ternary digits.
 \\ Return the vector transformed by the ternary reflected Gray
 \\ code as for UArD.
 UArD_digits_hightolow_reversal(v) = {
   my(rev=0);
   for(i=1,#v, if(rev, v[i] = 2-v[i]);
               if(v[i]==1, rev = !rev));
   v;
 }

gp_inline__location="../triples.tex:2950";
 UArD_row_pq(depth) = {
   my(mv = [ u, a, d ]);
   vector(3^depth,n,n--;
          my(v = digits_padded(n,3,depth));
          v = UArD_digits_hightolow_reversal(v);
          v = Vecrev(v);
          prod(i=1,#v, mv[v[i]+1]) * [2;1]);
 }

gp_inline__location="../triples.tex:2962";
 UArD_row_ABC(depth) = apply(pq_to_ABC, UArD_row_pq(depth));

gp_inline__location="../triples.tex:3137";
 UArD_row_pq_is_steps(depth) = {
   my(v = UArD_row_pq(depth),
      good = 1);
   v = vector_increments(v);
   for(i=1,#v,
       if(i%2==1,
          if(v[i][2,1],              good = 0),   \\ want horizontal
          if(v[i][1,1] != v[i][2,1], good = 0))); \\ want diagonal
   good;
 }

gp_inline__location="../triples.tex:3300";
 UArD_hdist(k) = {
   k>=0 || error("UArD_hdist() is for k>=0");
   Pell(2*k);
 }

gp_inline__location="../triples.tex:3311";
 UArD_row_pq_horizontal_total(depth) = {
   my(v=UArD_row_pq(depth));
   v=vector_increments(v);
   sum(i=1,#v, if(v[i][2,1]==0, abs(v[i][1,1])));
 }

gp_inline__location="../triples.tex:3327";
 UArD_ddist(k) = {
   k>=0 || error("UArD_ddist() is for k>=0");
   sum(i=1,2*k, (-1)^i * Pell(i));
 }

gp_inline__location="../triples.tex:3334";
 UArD_row_pq_diagonal_total(depth) = {
   my(v=UArD_row_pq(depth));
   v=vector_increments(v);
   sum(i=1,#v, if(v[i][1,1]==v[i][2,1], abs(v[i][1,1])));
 }

gp_inline__location="../triples.tex:3350";
 UArD_ddist_samples = {[0,1,8,49,288,1681,9800]};

gp_inline__location="../triples.tex:3901";
 UArD_long_W = [(3*'p+3*'q)/2; ('p+'q)/2];

gp_inline__location="../triples.tex:3928";
 UArD_low_to_high_row_pq(depth) = {
   my(mv = [ u, a, d ]);
   vector(3^depth,n,n--;
          my(v = digits_padded(n,3,depth));
          v = UArD_digits_hightolow_reversal(v);
          prod(i=1,#v, mv[v[i]+1]) * [2;1]);
 }
 cmp_arg_of_points(z1,z2) = {
   my(a=geom_point_x(z1), b=geom_point_y(z1),
      c=geom_point_x(z2), d=geom_point_y(z2));
   lex(0, a*d - b*c);
 }

gp_inline__location="../triples.tex:4055";
 pq_to_complex(pq) = pq[1,1] + pq[2,1]*I;
 UArD_low_to_high_row_pq_is_clockwise(depth) = {
   my(v = UArD_low_to_high_row_pq(depth),
      good = 1);
   for(i=1,#v-1,
       my(z1 = pq_to_complex(v[i]),
          z2 = pq_to_complex(v[i+1]));
       if(imag(z1/z2) <= 0, good = 0));
   good;
 }

gp_inline__location="../triples.tex:4147";
 UAD_area_r(k) = 5*3^k - 3;

gp_inline__location="../triples.tex:4150";
 UAD_area_r_samples = {[2,12,42,132,402,1212,3642,10932]};

gp_inline__location="../triples.tex:4165";
 UAD_area_R(k) = 5/2 * (3^k - 1) - 3*k;

gp_inline__location="../triples.tex:4170";
 UAD_area_R_samples = {[0,2,14,56,188,590,1802,5444,16376]};

gp_inline__location="../triples.tex:4178";
 UAD_area_r_polygon(depth) = {
   apply(pq_to_complex,
         concat(UArD_low_to_high_row_pq(depth),
                Vecrev(UArD_low_to_high_row_pq(depth+1))));
 }
 UAD_area_r_by_points(d) = \
   geom_area_of_polygon(UAD_area_r_polygon(d));

gp_inline__location="../triples.tex:4187";
 UAD_area_R_polygon(depth) = {
   apply(pq_to_complex,
         concat([ [2;1] ],
                Vecrev(UArD_low_to_high_row_pq(depth))));
 }
 UAD_area_R_by_points(d) = \
   geom_area_of_polygon(UAD_area_R_polygon(d));

gp_inline__location="../triples.tex:4761";
 sbL = {[1,0;1,1]};

gp_inline__location="../triples.tex:4773";
 sbR = {[1,1;0,1]};

gp_inline__location="../triples.tex:4817";
 swapS = {[0,1;1,0]};

gp_inline__location="../triples.tex:4852";
 FB_matrices = [m1,m2,m3];

gp_inline__location="../triples.tex:4854";
 \\ a vector of all [p;q] across row "depth"
 FB_row_pq(depth) = {
   vector(3^depth,n,n--;
     my(v=Vecrev(digits_padded(n,3,depth))); \\ low to high
     prod(i=1,#v, FB_matrices[v[i]+1]) * [2;1]);
 }
 FB_row_p(depth) = apply(v->v[1,1], FB_row_pq(depth));
 FB_row_q(depth) = apply(v->v[2,1], FB_row_pq(depth));

gp_inline__location="../triples.tex:4866";
 \\ a vector of all [A;B;C] across row "depth"
 FB_row_ABC(depth) = apply(pq_to_ABC, FB_row_pq(depth));
 FB_row_A(depth) = apply(v->v[1,1], FB_row_ABC(depth));
 FB_row_B(depth) = apply(v->v[2,1], FB_row_ABC(depth));
 FB_row_C(depth) = apply(v->v[3,1], FB_row_ABC(depth));

gp_inline__location="../triples.tex:5216";
 UMT_matrices = [u,m2,t];

gp_inline__location="../triples.tex:5723";
 T_repeatedly_p(k) = 3*2^k - 1;

gp_inline__location="../triples.tex:5728";
T_repeatedly_p_samples = {[2,5,11,23,47]};

gp_inline__location="../triples.tex:5738";
 T_repeatedly_q(k) = 2^k;

gp_inline__location="../triples.tex:5743";
T_repeatedly_q_samples = {[1,2,4,8,16]};

gp_inline__location="../triples.tex:5797";
 T_repeatedly_B_leg(k) = (3*2^k - 1) * 2^(k+1);

gp_inline__location="../triples.tex:5803";
 T_repeatedly_A_leg(k) = (2^(k+2) - 1)*(2^(k+1) - 1);

gp_inline__location="../triples.tex:5813";
 T_repeatedly_C_hypot(k) = 10*4^k - 6*2^k + 1;

gp_inline__location="../triples.tex:5820";
T_repeatedly_A_samples = {[3,21,105,465]};

gp_inline__location="../triples.tex:5830";
T_repeatedly_B_samples = {[4,20,88,368]};

gp_inline__location="../triples.tex:5841";
 T_repeatedly_C_leg(k) = (3*2^k - 1) * 2^(k+1);

gp_inline__location="../triples.tex:5843";
T_repeatedly_C_samples = {[5,29,137,593]};

gp_inline__location="../triples.tex:6493";
 possible_trees_map = Map();
 add_possible_trees_step(from_to,matrices) = {
   if(mapisdefined(possible_trees_map,from_to), error());
   mapput(possible_trees_map,from_to,matrices);
 }

gp_inline__location="../triples.tex:6502";
 add_possible_trees_step([21,32], [u,m1]);

gp_inline__location="../triples.tex:6567";
 add_possible_trees_step([21,41], [m2,d]);

gp_inline__location="../triples.tex:6644";
 x1 = {[3,-2;2,-1]};

gp_inline__location="../triples.tex:6654";
 add_possible_trees_step([21,43], [m3,x1]);

gp_inline__location="../triples.tex:6736";
x2 = {[3,-1;2,-2]};

gp_inline__location="../triples.tex:6745";
 add_possible_trees_step([21,52], [a,t,x2]);

gp_inline__location="../triples.tex:6784";
 add_possible_trees_step([32,43], [u]);

gp_inline__location="../triples.tex:6851";
 add_possible_trees_step([41,52], [m1]);

gp_inline__location="../triples.tex:7589";
 p_from_dq(d,q) = d+q;

gp_inline__location="../triples.tex:7600";
 A_leg_from_dq(d,q) = d^2 + 2*d*q;
 B_leg_from_dq(d,q) = 2*q^2 + 2*d*q;
 C_leg_from_dq(d,q) = d^2 + 2*d*q + 2*q^2;

gp_inline__location="../triples.tex:7643";
 H = {[1,-1;0,1]};

gp_inline__location="../triples.tex:7786";
 Jdq = {[0,1;1,0]};

gp_inline__location="../triples.tex:7808";
 lpt = [ 1/2, 1, -1/2;  1,-1,1;  1/2, -1, 3/2 ];

gp_inline__location="../triples.tex:7826";
 Jpq = [1,0; 1,-1];

gp_inline__location="../triples.tex:7871";
 s_from_pq(p,q) = p + q;
 d_from_pq(p,q) = p - q;
 p_from_sd(s,d) = (s + d)/2;
 q_from_sd(s,d) = (s - d)/2;

gp_inline__location="../triples.tex:7885";
 A_leg_from_sd(s,d) = s*d;
 B_leg_from_sd(s,d) = (s^2 - d^2)/2;
 C_leg_from_sd(s,d) = (s^2 + d^2)/2;

gp_inline__location="../triples.tex:8080";
 sdmapF = {[1,1;1,-1]};

gp_inline__location="../triples.tex:8955";
 \\ is_variable(str) returns true if str is the name of a variable,
 \\ meaning a "foo" not equal to its own symbol 'foo.
 is_variable(str) = eval(str)!=eval(Str("'",str));

gp_inline__location="../triples.tex:8960";
 char_variables_allowed = Set(["u","a","d","t", "f"]);
 check_char_variables() = {
   my(char_variables_ok = 1);
   for(ch=Vecsmall("a")[1], Vecsmall("z")[1],
       my(str = Strchr(ch));
       if(is_variable(str) && ! setsearch(char_variables_allowed,str),
          print(str," = ",eval(str)); char_variables_ok = 0));
   char_variables_ok;
 }

kill(gp_inline__location);
